moSetGetInputOutputUpk = {};

function getChildrenFromModule(module,list)
	if(module.kids ~= nil)then
		for _,kid in pairs(module.kids) do
			table.insert(list,kid);
			getChildrenFromModule(kid,list);
		end
	end
end

---upk mods---
function moSetGetInputOutputUpk:getUpk(self, objectTable, category)
	--print('try to get upk, category '..tostring(category))
	if objectTable == nil then return nil, nil;end;
	local moduleList = {}; -- list of modules used in that mod
	getChildrenFromModule(objectTable,moduleList);	
	local inputFillTypes;
	local outputFillTypes;
	if category == "heaps" then inputFillTypes, outputFillTypes = moSetGetInputOutputUpk:getUpkHeaps(self, moduleList);end;
	if category ~= "heaps" and category == "trees" then	inputFillTypes, outputFillTypes = moSetGetInputOutputUpk:getUpkTrees(self, moduleList);end;	
	----alte aktivieren zeile 20,dein neues aktivieren zeile 21	
	if category ~= "heaps" and category ~= "trees" then inputFillTypes, outputFillTypes = moSetGetInputOutputUpk:getUpkFactoryOld(self, moduleList, category);end;
	--if category ~= "heaps" then inputFillTypes, outputFillTypes = moSetGetInputOutputUpk:getUpkFactoryNew(self, moduleList);end;
	return inputFillTypes, outputFillTypes;
end;

---heaps extra und klappt so perfekt
function moSetGetInputOutputUpk:getUpkHeaps(self, moduleList)
	local inputFillTypes = {};
	local outputFillTypes = {};
	local foundHeapsFillLevel = false;
	local container = 1;
	local cancel = false;
	for _,module in pairs(moduleList) do
		if cancel then break;end;
		local type=module.type
		if type=="baletrigger" or type=="dumptrigger" or type=="emptytrigger" or type=="pallettrigger" or type=="tiptrigger" then
			local acceptedFillTypes={}
			if(module.acceptedFillTypes~=nil) then				
				acceptedFillTypes = module.acceptedFillTypes
			elseif(module.emptyFillTypes ~= nil) then -- used in emptytrigger
				acceptedFillTypes = module.emptyFillTypes				
			end;			
			local info = {};
			info.fillTypeName = "";						
			info.pricePerLiter = 0;
			info.capacity = 0;
			info.fillLevel = 0;
			info.lengthFillTypes = 0;
			info.fillTypeContainerName = nil;
			for fillType,isAccepted in pairs(acceptedFillTypes) do				
				if cancel then break;end;
				if(isAccepted)then
					local flb=module:getFillLevelBubbleShellFromFillType(fillType)
					if(flb~=nil)then						
						info.fillLevel = flb:getFillLevel(fillType);						
						if info.fillLevel > 0.1 then cancel = true;foundHeapsFillLevel = true;info.fillTypeName = "";info.fillTypeContainerName = nil;end;
						local pricePerLiter, fillTypeNameString = moSetGetInputOutputUpk:getFillTypeStringName(self, fillType, info.fillTypeName, UniversalProcessKit.fillTypeIntToName[fillType]);
						if info.fillTypeName ~= fillTypeNameString then info.lengthFillTypes = info.lengthFillTypes+1;info.fillTypeName = fillTypeNameString;end;
						info.fillTypeName = fillTypeNameString;
						info.pricePerLiter = pricePerLiter;
					end;
				end;
			end;
			if not foundHeapsFillLevel then
				info.fillTypeContainerName = tostring(moLanguageXml:getTxt("empty", nil, "--Empty--"));				
				inputFillTypes[container] = {};
				table.insert(inputFillTypes[container], info);
				break;
			else
				info.lengthFillTypes = 1;
				outputFillTypes[container] = {};
				table.insert(outputFillTypes[container], info);
			end;
			container = container+1;
		end;
	end;	
	return inputFillTypes, outputFillTypes;
end;
---heaps extra und klappt so perfekt

---trees extra und klappt so perfekt
function moSetGetInputOutputUpk:getUpkTrees(self, moduleList)
	local inputFillTypes = {};
	local outputFillTypes = {};	
	local container = 1;
	local cancel = false;
	local productivity = 0;
	local productivityColor = moGuiMiniPdaSlots.warningColor0;
	for _,module in pairs(moduleList) do
		if cancel then break;end;
		local type=module.type
		if type=="filltrigger" or type=="gasstationtrigger" or type=="liquidmanurefilltrigger" or type=="sprayerfilltrigger" or type=="waterfilltrigger" then
			local fillTypes={}			
			if(module.fillType~=nil) or (module.fillFillType~=nil) then								
				if module.fillFillType ~= nil then
					fillTypes[module.fillFillType] = {};
					fillTypes[module.fillFillType] = true;
				elseif module.fillType ~= nil then					
					fillTypes[module.fillType] = {};
					fillTypes[module.fillType] = true;
				end;	
			elseif(type=="gasstationtrigger") then
				fillTypes[FillUtil.FILLTYPE_FUEL] = {};
				fillTypes[FillUtil.FILLTYPE_FUEL] = true;				
			elseif(type=="liquidmanurefilltrigger") then
				fillTypes[FillUtil.FILLTYPE_LIQUIDMANURE] = {};
				fillTypes[FillUtil.FILLTYPE_LIQUIDMANURE] = true;				
			elseif(type=="sprayerfilltrigger") then
				fillTypes[FillUtil.FILLTYPE_FERTILIZER] = {};
				fillTypes[FillUtil.FILLTYPE_FERTILIZER] = true;				
			elseif(type=="waterfilltrigger") then
				fillTypes[FillUtil.FILLTYPE_WATER] = {};
				fillTypes[FillUtil.FILLTYPE_WATER] = true;				
			end
			local info = {};
			info.fillTypeName = "";						
			info.pricePerLiter = 0;
			info.capacity = 0;
			info.fillLevel = 0;
			info.lengthFillTypes = 0;			
			for fillType,isAccepted in pairs(fillTypes) do
				if cancel then break;end;
				if(isAccepted)then
					local flb=module:getFillLevelBubbleShellFromFillType(fillType)
					if(flb~=nil)then
						info.capacity=flb:getCapacity(fillType);
						info.fillLevel = flb:getFillLevel(fillType);						
						if info.fillLevel > 0.1 then cancel = true;info.fillTypeName = "";end;
						local pricePerLiter, fillTypeNameString = moSetGetInputOutputUpk:getFillTypeStringName(self, fillType, info.fillTypeName, UniversalProcessKit.fillTypeIntToName[fillType]);
						if info.fillTypeName ~= fillTypeNameString then info.lengthFillTypes = info.lengthFillTypes+1;info.fillTypeName = fillTypeNameString;end;
						info.fillTypeName = fillTypeNameString;
						info.pricePerLiter = pricePerLiter;					
					end
				end
			end	
			info.lengthFillTypes = 1;
			outputFillTypes[container] = {};
			table.insert(outputFillTypes[container], info);			
			productivity = Utils.getNoNil(info.fillLevel/info.capacity*100, 0);			
			if tonumber(productivity) <= 90 and tonumber(productivity) >= 75 then
				productivityColor = moGuiMiniPdaSlots.warningColor1;
			elseif tonumber(productivity) < 75 and tonumber(productivity) >= 50 then
				productivityColor = moGuiMiniPdaSlots.warningColor2;
			elseif tonumber(productivity) < 50 and tonumber(productivity) >= 25 then
				productivityColor = moGuiMiniPdaSlots.warningColor3;
			elseif tonumber(productivity) < 25 then
				productivityColor = moGuiMiniPdaSlots.warningColor4;
			end;			
			outputFillTypes[1][1].productivity = productivity;
			outputFillTypes[1][1].productivityColor = productivityColor;
			container = container+1;
		end;		
	end;	
	return inputFillTypes, outputFillTypes;
end;
---trees extra und klappt so perfekt

---dein neues script teil
function moSetGetInputOutputUpk:getUpkFactoryNew(self, moduleList)
	local inputFillTypes = {};
	local outputFillTypes = {};
	local inputFillTypesTemp = {};
	local outputFillTypesTemp = {};
	local containerInput = 1;
	local containerOutput = 1;
	for _,module in pairs(moduleList) do
		local type=module.type
		if type=="baletrigger" or type=="dumptrigger" or type=="emptytrigger" or type=="pallettrigger" or type=="tiptrigger" then
			local acceptedFillTypes={}
			if(module.acceptedFillTypes~=nil) then
				acceptedFillTypes=module.acceptedFillTypes
			elseif(module.emptyFillTypes~=nil) then -- used in emptytrigger
				acceptedFillTypes=module.emptyFillTypes
			end
			for fillType,isAccepted in pairs(acceptedFillTypes) do
				if(isAccepted)then
					-- convert fill types
					local tmpmodule=module

					local convertedFillType=fillType
					local flbs=module.p_flbs
					
					--print('fillType= '..tostring(fillType))
					--print('UniversalProcessKit= '..tostring(UniversalProcessKit))
					--print('UniversalProcessKit.FILLTYPE_UNKNOWN= '..tostring(UniversalProcessKit.FILLTYPE_UNKNOWN))
					
					local breakvar=false
					
					repeat
						--print('repeat in '..tostring(tmpmodule.name))
							
						convertedFillType=tmpmodule.fillTypesConversionMatrix[convertedFillType][UniversalProcessKit.FILLTYPE_UNKNOWN] or convertedFillType
						flbs=tmpmodule:getFillLevelBubbleShellFromFillType(convertedFillType)
						
						breakvar = (tmpmodule==module.base or tmpmodule.p_flbs==flbs)
						
						--print('convertedFillType= '..tostring(convertedFillType))
						--print('flbs= '..tostring(flbs)..' tmpmodule.p_flbs= '..tostring(tmpmodule.p_flbs))
						
						tmpmodule=tmpmodule.parent
					until breakvar or tmpmodule==nil
					--print('repeat end')
					
					if(flbs~=nil)then
						-- check for single storage
						local flbFillType=flbs:getFillType()
						--print('flbFillType='..tostring(flbFillType))
						if flbFillType==UniversalProcessKit.FILLTYPE_UNKNOWN or flbFillType==convertedFillType then
							local alreadyInTable=false
							if inputFillTypesTemp[convertedFillType]==nil then
								inputFillTypesTemp[convertedFillType]={}
							else
								for k,t in pairs(inputFillTypesTemp[convertedFillType]) do
									if(t.flb==flbs[convertedFillType]) then
										alreadyInTable=true
										break
									end
								end
							end
							
							if(not alreadyInTable)then
								local info={}
								info.flbs=flbs
								info.capacity=flbs:getCapacity(convertedFillType)
								info.fillLevel=flbs:getFillLevel(convertedFillType)
								info.productivity=0
								if info.capacity<math.huge then
									info.productivity=info.fillLevel/info.capacity
								end
								info.pricePerLiter=module:getRevenuePerLiter(convertedFillType)
								info.name=flbs.name
								---wird benötigt
								info.lengthFillTypes = 0;
								info.container = containerInput;
								info.fillTypeName = "";
								local pricePerLiter, fillTypeNameString = moSetGetInputOutputUpk:getFillTypeStringName(self, convertedFillType, info.fillTypeName, UniversalProcessKit.fillTypeIntToName[convertedFillType]);
								if info.fillTypeName ~= fillTypeNameString then info.lengthFillTypes = info.lengthFillTypes+1;info.fillTypeName = fillTypeNameString;end;								
								if info.pricePerLiter == nil or info.revenuePerLiter == 0 then
									info.pricePerLiter = pricePerLiter;
								end;
								--wird benötigt								
								print('INFO '..tostring(info.name)..' stores '..tostring(UniversalProcessKit.fillTypeIntToName[convertedFillType])..': capacity '..tostring(info.capacity)..' fillLevel '..tostring(info.fillLevel))
								table.insert(inputFillTypesTemp[convertedFillType],info)
								containerInput = containerInput+1;
							end
						end
					end
				end
			end
		elseif type=="filltrigger" or type=="gasstationtrigger" or type=="liquidmanurefilltrigger" or type=="sprayerfilltrigger" or type=="waterfilltrigger" then
			--local fillTypes={}			
			--if(#module.fillFillTypes~=0) then
			--	for _,v in pairs(module.fillFillTypes) do
			--		table.insert(fillTypes,v,true)
			--	end
			--elseif(module.fillFillType~=nil) then
			--	table.insert(fillTypes,module.fillFillType,true)
			--elseif(type=="gasstationtrigger") then
			--	table.insert(fillTypes,FillUtil.FILLTYPE_FUEL,true)
			--elseif(type=="liquidmanurefilltrigger") then
			--	table.insert(fillTypes,FillUtil.FILLTYPE_LIQUIDMANURE,true)
			--elseif(type=="sprayerfilltrigger") then
			--	table.insert(fillTypes,FillUtil.FILLTYPE_FERTILIZER,true)
			--elseif(type=="waterfilltrigger") then
			--	table.insert(fillTypes,FillUtil.FILLTYPE_WATER,true)
			--end
			--for fillType,isAccepted in pairs(fillTypes) do
			--	if(isAccepted)then
					
					-- check if filltype exists in game
			--		if FillUtil.fillTypeIntToName[fillType]~=nil then
			--			local flb=module:getFillLevelBubbleShellFromFillType(fillType)
			--			if(flb~=nil)then
			--				local alreadyInTable=false
			--				if inputFillTypesTemp[convertedFillType]==nil then
			--					inputFillTypesTemp[convertedFillType]={}
			--				else
			--					for k,t in pairs(inputFillTypesTemp[convertedFillType]) do
			--						if(t.flb==flbs[convertedFillType]) then
			--							alreadyInTable=true
			--							break
			--						end
			--					end
			--				end
			--				if(not alreadyInTable)then
			--					local info={}
			--					info.flbs=flbs
			--					info.capacity=flbs:getCapacity(fillType)
			--					info.fillLevel=flbs:getFillLevel(fillType)
			--					info.productivity=0
			--					if info.capacity<math.huge then
			--						info.productivity=info.fillLevel/info.capacity
			--					end
			--					info.pricePerLiter=module:getPricePerLiter(fillType)
			--					info.name=flbs.name
			--					containerOutput = containerOutput+1;
			--					table.insert(outputFillTypesTemp[fillType],info)
			--					containerOutput = containerOutput+1;
			--				end
			--			end
			--		end
			--	end
			--end
		end	
	end
	
	----inputFillTypesTemp/outputFillTypesTemp umwandeln damit das übergabe script die daten lesen und verarbeiten kann
	if inputFillTypesTemp ~= nil and category ~= "stocks" then
		for _,fillType in pairs(inputFillTypesTemp) do
			local container = fillType[1].container;						
			if inputFillTypes[container] == nil then
				inputFillTypes[container] = {};
				local info = {};
				info.capacity = fillType[1].capacity;
				info.fillLevel = fillType[1].fillLevel;
				info.fillTypeName = fillType[1].fillTypeName;
				info.lengthFillTypes = 1;
				info.pricePerLiter = fillType[1].pricePerLiter;
				table.insert(inputFillTypes[container], info);
			else
				inputFillTypes[container][1].capacity = inputFillTypes[container][1].capacity+fillType[1].capacity;
				inputFillTypes[container][1].fillLevel = inputFillTypes[container][1].fillLevel+fillType[1].fillLevel;
				local fillTypeName = inputFillTypes[container][1].fillTypeName;
				if string.len(fillTypeName) > 0 then
					inputFillTypes[container][1].fillTypeName = inputFillTypes[container][1].fillTypeName.. " ".. fillType[1].fillTypeName;
					inputFillTypes[container][1].lengthFillTypes = inputFillTypes[container][1].lengthFillTypes+1;
				else
					inputFillTypes[container][1].fillTypeName = inputFillTypes[container][1].fillTypeName;
					inputFillTypes[container][1].lengthFillTypes = 1;
				end;					
			end;
		end;	
	end;	
	if outputFillTypesTemp ~= nil and category ~= "shops" then
		for _,fillType in pairs(outputFillTypesTemp) do
			local container = fillType[1].container;			
			if outputFillTypes[container] == nil then				
				outputFillTypes[container] = {};
				local info = {};
				info.capacity = fillType[1].capacity;
				info.fillLevel = fillType[1].fillLevel;
				info.fillTypeName = fillType[1].fillTypeName;
				info.lengthFillTypes = 1;
				info.pricePerLiter = fillType[1].pricePerLiter;
				table.insert(outputFillTypes[container], info);
			else
				outputFillTypes[container][1].capacity = outputFillTypes[container][1].capacity+fillType[1].capacity;
				outputFillTypes[container][1].fillLevel = outputFillTypes[container][1].fillLevel+fillType[1].fillLevel;
				local fillTypeName = outputFillTypes[container][1].fillTypeName;
				if string.len(fillTypeName) > 0 then
					outputFillTypes[container][1].fillTypeName = outputFillTypes[container][1].fillTypeName.. " ".. fillType[1].fillTypeName;
					outputFillTypes[container][1].lengthFillTypes = outputFillTypes[container][1].lengthFillTypes+1;
				else
					outputFillTypes[container][1].fillTypeName = outputFillTypes[container][1].fillTypeName;
					outputFillTypes[container][1].lengthFillTypes = 1;
				end;					
			end;				
		end;			
	end;
	----inputFillTypesTemp/outputFillTypesTemp umwandeln damit das übergabe script die daten lesen und verarbeiten kann

	return inputFillTypes, outputFillTypes;
end;


----das alte script teil,was soweit klappt nur das die filllevel und die filltype alle extra sind
function moSetGetInputOutputUpk:getUpkFactoryOld(self, moduleList, category)	
	local inputFillTypes = {};
	local outputFillTypes = {};
	local inputFillTypesTemp = {};
	local outputFillTypesTemp = {};
	local containerInput = 1;
	local containerOutput = 1;	
	for _,module in pairs(moduleList) do
		local type=module.type
		if type=="baletrigger" or type=="dumptrigger" or type=="emptytrigger" or type=="pallettrigger" or type=="tiptrigger" and category ~= "stocks" then
			local acceptedFillTypes={}
			if(module.acceptedFillTypes~=nil) then				
				acceptedFillTypes=module.acceptedFillTypes
			elseif(module.emptyFillTypes~=nil) then -- used in emptytrigger
				acceptedFillTypes=module.emptyFillTypes				
			end
			local wheat_windrow = false;
			local grass_windrow = false;
			local foundHeapsFillLevel = true;
			local flbLast;
			for fillType,isAccepted in pairs(acceptedFillTypes) do
				if(isAccepted)then
					local flb=module:getFillLevelBubbleShellFromFillType(fillType)
					if(flb~=nil)then						
						local alreadyInTable=false						
						if inputFillTypesTemp[fillType] ~= nil then
							for _index,t in pairs(inputFillTypesTemp[fillType]) do
								if(t.flb==flb) then
									--local pricePerLiter, fillTypeNameString = getFillTypeStringName(self, fillType, inputFillTypes[container][1].fillTypeName, UniversalProcessKit.fillTypeIntToName[fillType], false, slotType);							
									--inputFillTypes[container][1].fillTypeName = fillTypeNameString;									
									alreadyInTable=true
									break
								end
							end
						end;
						if(not alreadyInTable) then --and not _windrow and not grass_windrow then
							local info={}
							info.flb=flb
							flbLast = flb;
							info.capacity=flb:getCapacity(fillType)
							info.fillLevel=flb:getFillLevel(fillType)
							if inputFillTypesTemp[fillType] == nil then								
								info.pricePerLiter=0;								
								info.name=flb.name							
								info.container = containerInput;																
								info.fillTypeName = "";								
								local pricePerLiter, fillTypeNameString = moSetGetInputOutputUpk:getFillTypeStringName(self, fillType, info.fillTypeName, UniversalProcessKit.fillTypeIntToName[fillType]);							
								info.fillTypeName = fillTypeNameString;
								if info.pricePerLiter == 0 then info.pricePerLiter = pricePerLiter;end;
								inputFillTypesTemp[fillType] = {};
								table.insert(inputFillTypesTemp[fillType],info)
								containerInput = containerInput+1;
							elseif not foundHeapsFillLevel then
								inputFillTypesTemp[fillType][1].capacity = inputFillTypesTemp[fillType][1].capacity+info.capacity;
								inputFillTypesTemp[fillType][1].fillLevel = inputFillTypesTemp[fillType][1].fillLevel+info.fillLevel;
							end
						end;
					end
					--if fillType == wheat_windrow or barley_windrow then wheat_windrow = true;end;
					--if fillType == gras_windrow or dryGrass_windrow then grass_windrow = true;end;						
				end
			end				
		elseif type=="filltrigger" or type=="gasstationtrigger" or type=="liquidmanurefilltrigger" or type=="sprayerfilltrigger" or type=="waterfilltrigger" and category ~= "shops" then
			local fillTypes={}			
			if(module.fillType~=nil) or (module.fillFillType~=nil) then								
				if module.fillFillType ~= nil then
					fillTypes[module.fillFillType] = {};
					fillTypes[module.fillFillType] = true;
				elseif module.fillType ~= nil then					
					fillTypes[module.fillType] = {};
					fillTypes[module.fillType] = true;
				end;	
			elseif(type=="gasstationtrigger") then
				fillTypes[FillUtil.FILLTYPE_FUEL] = {};
				fillTypes[FillUtil.FILLTYPE_FUEL] = true;				
			elseif(type=="liquidmanurefilltrigger") then
				fillTypes[FillUtil.FILLTYPE_LIQUIDMANURE] = {};
				fillTypes[FillUtil.FILLTYPE_LIQUIDMANURE] = true;				
			elseif(type=="sprayerfilltrigger") then
				fillTypes[FillUtil.FILLTYPE_FERTILIZER] = {};
				fillTypes[FillUtil.FILLTYPE_FERTILIZER] = true;				
			elseif(type=="waterfilltrigger") then
				fillTypes[FillUtil.FILLTYPE_WATER] = {};
				fillTypes[FillUtil.FILLTYPE_WATER] = true;				
			end
			for fillType,isAccepted in pairs(fillTypes) do
				if(isAccepted)then
					local flb=module:getFillLevelBubbleShellFromFillType(fillType)
					if(flb~=nil)then
						local alreadyInTable=false
						if outputFillTypesTemp[fillType] ~= nil then
							for _index,t in pairs(outputFillTypesTemp[fillType]) do
								if(t.flb==flb) then
									--local pricePerLiter, fillTypeNameString = getFillTypeStringName(self, fillType, outputFillTypes[container][1].fillTypeName, UniversalProcessKit.fillTypeIntToName[fillType], false, slotType);							
									--outputFillTypes[container][1].fillTypeName = fillTypeNameString;	
									alreadyInTable=true
									break
								end
							end
						end;
						if(not alreadyInTable)then
							local info={}
							info.flb=flb							
							info.capacity=flb:getCapacity(fillType)
							info.fillLevel=flb:getFillLevel(fillType)							
							if outputFillTypesTemp[fillType] == nil then
								info.pricePerLiter=Utils.getNoNil(module:getPricePerLiter(fillType), 0);								
								info.name=flb.name
								info.container = containerOutput;
								containerOutput = containerOutput+1;								
								outputFillTypesTemp[fillType] = {};
								info.fillTypeName = "";								
								local pricePerLiter, fillTypeNameString = moSetGetInputOutputUpk:getFillTypeStringName(self, fillType, info.fillTypeName, UniversalProcessKit.fillTypeIntToName[fillType]);							
								info.fillTypeName = fillTypeNameString;								
								if info.pricePerLiter == 0 then	info.pricePerLiter = pricePerLiter;end;					
								table.insert(outputFillTypesTemp[fillType], info)
							else
								outputFillTypesTemp[fillType][1].capacity = outputFillTypesTemp[fillType][1].capacity+info.capacity;
								outputFillTypesTemp[fillType][1].fillLevel = outputFillTypesTemp[fillType][1].fillLevel+info.fillLevel;
							end;							
						end
					end
				end
			end			
		end;		
	end;
	local ratio = 0;	
	local productivity = 0;
	local productivityColor = moGuiMiniPdaSlots.warningColor0;
	local outputFull = false;
	local inputEmty = false;
	local capacity = 0;
	local fillLevel = 0;		
	if outputFillTypesTemp ~= nil and category ~= "shops" then
		for _,fillType in pairs(outputFillTypesTemp) do
			local container = fillType[1].container;			
			if outputFillTypes[container] == nil then				
				outputFillTypes[container] = {};
				local info = {};
				info.capacity = fillType[1].capacity;
				info.fillLevel = fillType[1].fillLevel;
				ratio = Utils.getNoNil(info.fillLevel/info.capacity*100, 0);
				if tonumber(ratio) >= 100 then outputFull = true;end;
				info.fillTypeName = fillType[1].fillTypeName;
				info.lengthFillTypes = 1;
				info.pricePerLiter = fillType[1].pricePerLiter;
				table.insert(outputFillTypes[container], info);
			else
				outputFillTypes[container][1].capacity = outputFillTypes[container][1].capacity+fillType[1].capacity;
				outputFillTypes[container][1].fillLevel = outputFillTypes[container][1].fillLevel+fillType[1].fillLevel;
				ratio = Utils.getNoNil(outputFillTypes[container][1].fillLevel/outputFillTypes[container][1].capacity*100, 0);
				if tonumber(ratio) >= 100 then outputFull = true;end;
				local fillTypeName = outputFillTypes[container][1].fillTypeName;
				if string.len(fillTypeName) > 0 then
					outputFillTypes[container][1].fillTypeName = outputFillTypes[container][1].fillTypeName.. " ".. fillType[1].fillTypeName;
					outputFillTypes[container][1].lengthFillTypes = outputFillTypes[container][1].lengthFillTypes+1;
				else
					outputFillTypes[container][1].fillTypeName = outputFillTypes[container][1].fillTypeName;
					outputFillTypes[container][1].lengthFillTypes = 1;
				end;					
			end;				
		end;			
	end;
	if inputFillTypesTemp ~= nil and category ~= "stocks" then
		for _,fillType in pairs(inputFillTypesTemp) do
			local container = fillType[1].container;						
			if inputFillTypes[container] == nil then
				inputFillTypes[container] = {};
				local info = {};
				info.capacity = fillType[1].capacity;
				info.fillLevel = fillType[1].fillLevel;
				if info.fillLevel <= 0.1 then inputEmty = true;end;
				if not outputFull then
					if not inputEmty then
						capacity = capacity+info.capacity;
						fillLevel = fillLevel+info.fillLevel;
					end;					
				end;
				info.fillTypeName = fillType[1].fillTypeName;
				info.lengthFillTypes = 1;
				info.pricePerLiter = fillType[1].pricePerLiter;
				table.insert(inputFillTypes[container], info);
			else
				inputFillTypes[container][1].capacity = inputFillTypes[container][1].capacity+fillType[1].capacity;
				inputFillTypes[container][1].fillLevel = inputFillTypes[container][1].fillLevel+fillType[1].fillLevel;
				if inputFillTypes[container][1].fillLevel <= 0.1 then inputEmty = true;end;
				if not outputFull then
					if not inputEmty then
						capacity = inputFillTypes[container][1].capacity;
						fillLevel = inputFillTypes[container][1].fillLevel;
					end;					
				end;
				local fillTypeName = inputFillTypes[container][1].fillTypeName;
				if string.len(fillTypeName) > 0 then
					inputFillTypes[container][1].fillTypeName = inputFillTypes[container][1].fillTypeName.. " ".. fillType[1].fillTypeName;
					inputFillTypes[container][1].lengthFillTypes = inputFillTypes[container][1].lengthFillTypes+1;
				else
					inputFillTypes[container][1].fillTypeName = inputFillTypes[container][1].fillTypeName;
					inputFillTypes[container][1].lengthFillTypes = 1;
				end;					
			end;
		end;	
	end;
	if category ~= "shops" and category ~= "stocks" and outputFillTypes[1] ~= nil then
		productivity = Utils.getNoNil(fillLevel/capacity*100, 0);
		if not outputFull and not inputEmty then
			if tonumber(productivity) <= 90 and tonumber(productivity) >= 75 then
				productivityColor = moGuiMiniPdaSlots.warningColor1;
			elseif tonumber(productivity) < 75 and tonumber(productivity) >= 50 then
				productivityColor = moGuiMiniPdaSlots.warningColor2;
			elseif tonumber(productivity) < 50 and tonumber(productivity) >= 25 then
				productivityColor = moGuiMiniPdaSlots.warningColor3;
			elseif tonumber(productivity) < 25 then
				productivityColor = moGuiMiniPdaSlots.warningColor4;
			end;
		else
			if inputEmty then 
				productivity = 0;
				productivityColor = moGuiMiniPdaSlots.warningColor4;
			else
				productivity = 50;
				productivityColor = moGuiMiniPdaSlots.warningColor2;
			end;
		end;
		outputFillTypes[1][1].productivity = productivity;
		outputFillTypes[1][1].productivityColor = productivityColor;		
	end;
	return inputFillTypes, outputFillTypes	
end;

function moSetGetInputOutputUpk:getFillTypeStringName(self, fillType, fillTypeNameString, fillTypeName)
	local pricePerLiter = 0;
	local stringName = fillTypeNameString;
	local desc = FillUtil.fillTypeIndexToDesc[fillType];	
	if desc ~= nil and moFillTypes[desc.index] ~= nil and moFillTypes[desc.index].fruitName ~= nil then								
		local bestPriceTemp = 1;
		if moFillTypes[desc.index].bestPrice ~= 0 then bestPriceTemp = moFillTypes[desc.index].bestPrice;end;
		pricePerLiter = moFillTypes[desc.index].pricePerLiter*bestPriceTemp*moGeneralSettings.difficultyMultiplier*moFillTypes[desc.index].greatDemandMultiplier*1000;		
		if not string.find(stringName, moFillTypes[desc.index].fruitName) then
			if string.len(stringName) > 0 then
				stringName = stringName.. ",".. moFillTypes[desc.index].fruitName;									
			else
				stringName = moFillTypes[desc.index].fruitName;
			end;								
		end;
	elseif fillType >= 30000 or fillTypeName ~= nil then		
		if not string.find(stringName, fillTypeName) then
			if string.len(stringName) > 0 then
				stringName = stringName.. ",!".. fillTypeName;									
			else
				stringName = "!".. fillTypeName;
			end;								
		end;
	else
		if not string.find(stringName, tostring(moLanguageXml:getTxt("unknow"))) then
			if string.len(stringName) > 0 then
				stringName = stringName.. ",".. tostring(moLanguageXml:getTxt("unknow"));									
			else
				stringName = tostring(moLanguageXml:getTxt("unknow"));
			end;								
		end;	
	end;	
	return pricePerLiter, stringName
end;