moSetGetInputOutputUpk = {};

---upk mods---
function moSetGetInputOutputUpk:getUpk(self, objectTable, category)	
	if objectTable == nil then return nil, nil;end;
	local inputFillTypes = {};
	local outputFillTypes = {};
	local moduleList = {}; -- list of modules used in that mod
	function getChildrenFromModule(module,list)
		if(module.kids ~= nil)then
			for _,kid in pairs(module.kids) do
				table.insert(list,kid);
				getChildrenFromModule(kid,list);
			end
		end
	end
	getChildrenFromModule(objectTable,moduleList);
	if category == "heaps" then inputFillTypes, outputFillTypes = moSetGetInputOutputUpk:getUpkHeaps(self, moduleList);end;
	--if category ~= "heaps" then inputFillTypes, outputFillTypes = moSetGetInputOutputUpk:getUpkFactoryNew(self, moduleList, category);end;
	if category ~= "heaps" then inputFillTypes, outputFillTypes = moSetGetInputOutputUpk:getUpkFactory(self, moduleList, category);end;
	return inputFillTypes, outputFillTypes;
end;

function moSetGetInputOutputUpk:getUpkHeaps(self, moduleList)
	local inputFillTypesTemp = {};
	local outputFillTypesTemp = {};
	local foundHeapsFillLevel = false;
	local container = 1;
	local cancel = false;
	for _,module in pairs(moduleList) do
		if cancel then break;end;
		local type=module.type
		if type=="baletrigger" or type=="dumptrigger" or type=="emptytrigger" or type=="pallettrigger" or type=="tiptrigger" then
			local acceptedFillTypes={}
			if(module.acceptedFillTypes~=nil) then				
				acceptedFillTypes = module.acceptedFillTypes
			elseif(module.emptyFillTypes ~= nil) then -- used in emptytrigger
				acceptedFillTypes = module.emptyFillTypes				
			end;			
			local info = {};
			info.fillTypeName = "";						
			info.pricePerLiter = 0;
			info.capacity = 0;
			info.fillLevel = 0;
			info.lengthFillTypes = 1;
			info.fillTypeContainerName = nil;
			for fillType,isAccepted in pairs(acceptedFillTypes) do				
				if cancel then break;end;
				if(isAccepted)then
					local flb=module:getFillLevelBubbleShellFromFillType(fillType)
					if(flb~=nil)then						
						info.fillLevel = flb:getFillLevel(fillType);						
						if info.fillLevel > 0.1 then cancel = true;foundHeapsFillLevel = true;info.fillTypeName = "";info.fillTypeContainerName = nil;end;
						local pricePerLiter, fillTypeNameString = moSetGetInputOutputUpk:getFillTypeStringName(self, fillType, info.fillTypeName, UniversalProcessKit.fillTypeIntToName[fillType]);
						if info.fillTypeName ~= fillTypeNameString then info.lengthFillTypes = info.lengthFillTypes+1;info.fillTypeName = fillTypeNameString;end;
						info.fillTypeName = fillTypeNameString;
						info.pricePerLiter = pricePerLiter;
					end;
				end;
			end;
			if not foundHeapsFillLevel then
				info.fillTypeContainerName = tostring(moLanguageXml:getTxt("empty", nil, "--Empty--"));				
				inputFillTypesTemp[container] = {};
				table.insert(inputFillTypesTemp[container], info);
				break;
			else
				info.lengthFillTypes = 1;
				outputFillTypesTemp[container] = {};
				table.insert(outputFillTypesTemp[container], info);
			end;
			container = container+1;
		end;
	end;	
	return inputFillTypesTemp, outputFillTypesTemp;
end;

function moSetGetInputOutputUpk:getUpkFactoryNew(self, moduleList, category)	
	local inputFillTypes = {};
	local outputFillTypes = {};
	--local inputFillTypesTemp = {};
	--local outputFillTypesTemp = {};
	--local containerInput = 1;
	--local containerOutput = 1;	
	for _,module in pairs(moduleList) do
		local type=module.type
		if type=="baletrigger" or type=="dumptrigger" or type=="emptytrigger" or type=="pallettrigger" or type=="tiptrigger" then			
			local acceptedFillTypes={}
			if(module.acceptedFillTypes~=nil) then
				acceptedFillTypes=module.acceptedFillTypes
			elseif(module.emptyFillTypes~=nil) then -- used in emptytrigger
				acceptedFillTypes=module.emptyFillTypes
			end
			for fillType,isAccepted in pairs(acceptedFillTypes) do
				if(isAccepted)then					
					-- convert fill types					
					local moduleBase=module.base
					local tmpmodule=module
					local convertedFillType=fillType
					-- loop thru parents to figure it out					
					while tmpmodule~=moduleBase do
						convertedFillType=tmpmodule.fillTypesConversionMatrix[convertedFillType][UniversalProcessKit.FILLTYPE_UNKNOWN]
						tmpmodule=tmpmodule.parent
					end					
					convertedFillType=module.base.fillTypesConversionMatrix[convertedFillType][UniversalProcessKit.FILLTYPE_UNKNOWN]			
					local flb=module:getFillLevelBubbleShellFromFillType(convertedFillType)
					if(flb~=nil)then
						-- check for single storage
						local flbFillType=flb:getFillType()
						if flbFillType==Fillable.FILLTYPE_UNKNOWN or flbFillType==convertedFillType then
							local alreadyInTable=false
							for k,t in pairs(inputFillTypes[convertedFillType]) do
								if(t.flb==flb) then
									alreadyInTable=true
									break
								end
							end
							if(not alreadyInTable)then
								local info={}
								info.flb=flb
								info.capacity=flb:getCapacity(convertedFillType)
								info.fillLevel=flb:getFillLevel(convertedFillType)
								info.productivity=0
								if info.capacity<math.huge then
									info.productivity=info.fillLevel/info.capacity
								end
								info.revenuePerLiter=module:getRevenuePerLiter(convertedFillType)
								info.name=flb.name
								table.insert(inputFillTypes[convertedFillType],info)
							end
						end
					end
				end
			end
		elseif type=="filltrigger" or type=="gasstationtrigger" or type=="liquidmanurefilltrigger" or type=="sprayerfilltrigger" or type=="waterfilltrigger" then			
			local fillTypes={}
			if(module.fillType~=nil) then
				table.insert(fillTypes,module.fillType,true)
			elseif(type=="gasstationtrigger") then
				table.insert(fillTypes,Fillable.FILLTYPE_FUEL,true)
			elseif(type=="liquidmanurefilltrigger") then
				table.insert(fillTypes,Fillable.FILLTYPE_LIQUIDMANURE,true)
			elseif(type=="sprayerfilltrigger") then
				table.insert(fillTypes,Fillable.FILLTYPE_FERTILIZER,true)
			elseif(type=="waterfilltrigger") then
				table.insert(fillTypes,Fillable.FILLTYPE_WATER,true)
			end
			for fillType,isAccepted in pairs(fillTypes) do
				if(isAccepted)then
					
					-- check if filltype exists in game
					if Fillable.fillTypeIntToName[fillType]~=nil then
						local flb=module:getFillLevelBubbleShellFromFillType(fillType)
						if(flb~=nil)then
							local alreadyInTable=false
							for k,t in pairs(outputFillTypes[fillType]) do
								if(t.flb==flb) then
									alreadyInTable=true
									break
								end
							end
							if(not alreadyInTable)then
								local info={}
								info.flb=flb
								info.capacity=flb:getCapacity(fillType)
								info.fillLevel=flb:getFillLevel(fillType)
								info.productivity=0
								if info.capacity<math.huge then
									info.productivity=info.fillLevel/info.capacity
								end
								info.pricePerLiter=module:getPricePerLiter(fillType)
								info.name=flb.name
								table.insert(outputFillTypes[fillType],info)
							end
						end
					end
				end
			end
		end	
	end
	--return inputFillTypes, outputFillTypes
	return nil, nil;	
end;

function moSetGetInputOutputUpk:getUpkFactory(self, moduleList, category)	
	local inputFillTypes = {};
	local outputFillTypes = {};
	local inputFillTypesTemp = {};
	local outputFillTypesTemp = {};
	local containerInput = 1;
	local containerOutput = 1;
	local ratio = 0;
	local productivity = 100;
	local productivityColor = moGuiMiniPdaSlots.warningColor0;
	for _,module in pairs(moduleList) do
		local type=module.type
		if type=="baletrigger" or type=="dumptrigger" or type=="emptytrigger" or type=="pallettrigger" or type=="tiptrigger" and category ~= "stocks" then
			local acceptedFillTypes={}
			if(module.acceptedFillTypes~=nil) then				
				acceptedFillTypes=module.acceptedFillTypes
			elseif(module.emptyFillTypes~=nil) then -- used in emptytrigger
				acceptedFillTypes=module.emptyFillTypes				
			end
			local wheat_windrow = false;
			local grass_windrow = false;
			for fillType,isAccepted in pairs(acceptedFillTypes) do
				if(isAccepted)then
					local flb=module:getFillLevelBubbleShellFromFillType(fillType)
					if(flb~=nil)then						
						local alreadyInTable=false						
						if inputFillTypesTemp[fillType] ~= nil then
							for _index,t in pairs(inputFillTypesTemp[fillType]) do
								if(t.flb==flb) then
									--local pricePerLiter, fillTypeNameString = getFillTypeStringName(self, fillType, inputFillTypes[container][1].fillTypeName, UniversalProcessKit.fillTypeIntToName[fillType], false, slotType);							
									--inputFillTypes[container][1].fillTypeName = fillTypeNameString;									
									alreadyInTable=true
									break
								end
							end
						end;
						if(not alreadyInTable) then --and not _windrow and not grass_windrow then
							local info={}
							info.flb=flb
							info.capacity=flb:getCapacity(fillType)
							info.fillLevel=flb:getFillLevel(fillType)
							if inputFillTypesTemp[fillType] == nil then								
								info.pricePerLiter=0;								
								info.name=flb.name							
								info.container = containerInput;																
								info.fillTypeName = "";								
								local pricePerLiter, fillTypeNameString = moSetGetInputOutputUpk:getFillTypeStringName(self, fillType, info.fillTypeName, UniversalProcessKit.fillTypeIntToName[fillType]);							
								info.fillTypeName = fillTypeNameString;
								if info.pricePerLiter == 0 then info.pricePerLiter = pricePerLiter;end;
								inputFillTypesTemp[fillType] = {};
								table.insert(inputFillTypesTemp[fillType],info)
								containerInput = containerInput+1;
							else
								inputFillTypesTemp[fillType][1].capacity = inputFillTypesTemp[fillType][1].capacity+info.capacity;
								inputFillTypesTemp[fillType][1].fillLevel = inputFillTypesTemp[fillType][1].fillLevel+info.fillLevel;
							end
						end;
					end
					--if fillType == wheat_windrow or barley_windrow then wheat_windrow = true;end;
					--if fillType == gras_windrow or dryGrass_windrow then grass_windrow = true;end;						
				end
			end				
		elseif type=="filltrigger" or type=="gasstationtrigger" or type=="liquidmanurefilltrigger" or type=="sprayerfilltrigger" or type=="waterfilltrigger" and category ~= "shops" then
			local fillTypes={}			
			if(module.fillType~=nil) or (module.fillFillType~=nil) then								
				if module.fillFillType ~= nil then
					fillTypes[module.fillFillType] = {};
					fillTypes[module.fillFillType] = true;
				elseif module.fillType ~= nil then					
					fillTypes[module.fillType] = {};
					fillTypes[module.fillType] = true;
				end;	
			elseif(type=="gasstationtrigger") then
				fillTypes[Fillable.FILLTYPE_FUEL] = {};
				fillTypes[Fillable.FILLTYPE_FUEL] = true;				
			elseif(type=="liquidmanurefilltrigger") then
				fillTypes[Fillable.FILLTYPE_LIQUIDMANURE] = {};
				fillTypes[Fillable.FILLTYPE_LIQUIDMANURE] = true;				
			elseif(type=="sprayerfilltrigger") then
				fillTypes[Fillable.FILLTYPE_FERTILIZER] = {};
				fillTypes[Fillable.FILLTYPE_FERTILIZER] = true;				
			elseif(type=="waterfilltrigger") then
				fillTypes[Fillable.FILLTYPE_WATER] = {};
				fillTypes[Fillable.FILLTYPE_WATER] = true;				
			end
			for fillType,isAccepted in pairs(fillTypes) do
				if(isAccepted)then
					local flb=module:getFillLevelBubbleShellFromFillType(fillType)
					if(flb~=nil)then
						local alreadyInTable=false
						if outputFillTypesTemp[fillType] ~= nil then
							for _index,t in pairs(outputFillTypesTemp[fillType]) do
								if(t.flb==flb) then
									--local pricePerLiter, fillTypeNameString = getFillTypeStringName(self, fillType, outputFillTypes[container][1].fillTypeName, UniversalProcessKit.fillTypeIntToName[fillType], false, slotType);							
									--outputFillTypes[container][1].fillTypeName = fillTypeNameString;	
									alreadyInTable=true
									break
								end
							end
						end;
						if(not alreadyInTable)then
							local info={}
							info.flb=flb							
							info.capacity=flb:getCapacity(fillType)
							info.fillLevel=flb:getFillLevel(fillType)													
							if outputFillTypesTemp[fillType] == nil then
								info.pricePerLiter=Utils.getNoNil(module:getPricePerLiter(fillType), 0);								
								info.name=flb.name
								info.container = containerOutput;
								containerOutput = containerOutput+1;								
								outputFillTypesTemp[fillType] = {};
								info.fillTypeName = "";								
								local pricePerLiter, fillTypeNameString = moSetGetInputOutputUpk:getFillTypeStringName(self, fillType, info.fillTypeName, UniversalProcessKit.fillTypeIntToName[fillType]);							
								info.fillTypeName = fillTypeNameString;								
								if info.pricePerLiter == 0 then	info.pricePerLiter = pricePerLiter;end;					
								table.insert(outputFillTypesTemp[fillType], info)
							else
								outputFillTypesTemp[fillType][1].capacity = outputFillTypesTemp[fillType][1].capacity+info.capacity;
								outputFillTypesTemp[fillType][1].fillLevel = outputFillTypesTemp[fillType][1].fillLevel+info.fillLevel;
							end;							
						end
					end
				end
			end			
		end;		
	end;	
	if inputFillTypesTemp ~= nil and category ~= "stocks" then
		for _,fillType in pairs(inputFillTypesTemp) do
			local container = fillType[1].container;						
			if inputFillTypes[container] == nil then
				inputFillTypes[container] = {};
				local info = {};
				info.capacity = fillType[1].capacity;
				info.fillLevel = fillType[1].fillLevel;
				ratio = Utils.getNoNil(info.fillLevel/info.capacity*100, 0);
				if tonumber(productivity) >= tonumber(ratio) then
					productivity = tonumber(ratio);	
				end;
				info.fillTypeName = fillType[1].fillTypeName;
				info.lengthFillTypes = 1;
				info.pricePerLiter = fillType[1].pricePerLiter;
				table.insert(inputFillTypes[container], info);
			else
				inputFillTypes[container][1].capacity = inputFillTypes[container][1].capacity+fillType[1].capacity;
				inputFillTypes[container][1].fillLevel = inputFillTypes[container][1].fillLevel+fillType[1].fillLevel;
				ratio = Utils.getNoNil(inputFillTypes[container][1].fillLevel/inputFillTypes[container][1].capacity*100, 0);
				if tonumber(productivity) >= tonumber(ratio) then
					productivity = tonumber(ratio);	
				end;
				local fillTypeName = inputFillTypes[container][1].fillTypeName;
				if string.len(fillTypeName) > 0 then
					inputFillTypes[container][1].fillTypeName = inputFillTypes[container][1].fillTypeName.. " ".. fillType[1].fillTypeName;
					inputFillTypes[container][1].lengthFillTypes = inputFillTypes[container][1].lengthFillTypes+1;
				else
					inputFillTypes[container][1].fillTypeName = inputFillTypes[container][1].fillTypeName;
					inputFillTypes[container][1].lengthFillTypes = 1;
				end;					
			end;
		end;	
	end;	
	if outputFillTypesTemp ~= nil and category ~= "shops" then
		for _,fillType in pairs(outputFillTypesTemp) do
			local container = fillType[1].container;			
			if outputFillTypes[container] == nil then				
				outputFillTypes[container] = {};
				local info = {};
				info.capacity = fillType[1].capacity;
				info.fillLevel = fillType[1].fillLevel;
				ratio = Utils.getNoNil(info.fillLevel/info.capacity*100, 0);
				if tonumber(productivity) >= tonumber(ratio) then
					productivity = tonumber(ratio);	
				end;
				info.fillTypeName = fillType[1].fillTypeName;
				info.lengthFillTypes = 1;
				info.pricePerLiter = fillType[1].pricePerLiter;
				table.insert(outputFillTypes[container], info);
			else
				outputFillTypes[container][1].capacity = outputFillTypes[container][1].capacity+fillType[1].capacity;
				outputFillTypes[container][1].fillLevel = outputFillTypes[container][1].fillLevel+fillType[1].fillLevel;
				ratio = Utils.getNoNil(outputFillTypes[container][1].fillLevel/outputFillTypes[container][1].capacity*100, 0);
				if tonumber(productivity) >= tonumber(ratio) then
					productivity = tonumber(ratio);	
				end;
				local fillTypeName = outputFillTypes[container][1].fillTypeName;
				if string.len(fillTypeName) > 0 then
					outputFillTypes[container][1].fillTypeName = outputFillTypes[container][1].fillTypeName.. " ".. fillType[1].fillTypeName;
					outputFillTypes[container][1].lengthFillTypes = outputFillTypes[container][1].lengthFillTypes+1;
				else
					outputFillTypes[container][1].fillTypeName = outputFillTypes[container][1].fillTypeName;
					outputFillTypes[container][1].lengthFillTypes = 1;
				end;					
			end;			
		end;
		if tonumber(productivity) <= 90 and tonumber(productivity) >= 75 then
			productivityColor = moGuiMiniPdaSlots.warningColor1;
		elseif tonumber(productivity) < 75 and tonumber(productivity) >= 50 then
			productivityColor = moGuiMiniPdaSlots.warningColor2;
		elseif tonumber(productivity) < 50 and tonumber(productivity) >= 25 then
			productivityColor = moGuiMiniPdaSlots.warningColor3;
		elseif tonumber(productivity) < 25 then
			productivityColor = moGuiMiniPdaSlots.warningColor4;
		end;
		outputFillTypes[1][1].productivity = productivity;
		outputFillTypes[1][1].productivityColor = productivityColor;
	end;	
	return inputFillTypes, outputFillTypes	
end;

function moSetGetInputOutputUpk:getFillTypeStringName(self, fillType, fillTypeNameString, fillTypeName)
	local pricePerLiter = 0;
	local stringName = fillTypeNameString;
	local desc = Fillable.fillTypeIndexToDesc[fillType];	
	if desc ~= nil and moFillTypes[desc.index] ~= nil and moFillTypes[desc.index].fruitName ~= nil then								
		local bestPriceTemp = 1;
		if moFillTypes[desc.index].bestPrice ~= 0 then bestPriceTemp = moFillTypes[desc.index].bestPrice;end;
		pricePerLiter = moFillTypes[desc.index].pricePerLiter*bestPriceTemp*moGeneralSettings.difficultyMultiplier*moFillTypes[desc.index].greatDemandMultiplier*1000;		
		if not string.find(stringName, moFillTypes[desc.index].fruitName) then
			if string.len(stringName) > 0 then
				stringName = stringName.. " ".. moFillTypes[desc.index].fruitName;									
			else
				stringName = moFillTypes[desc.index].fruitName;
			end;								
		end;
	elseif fillType >= 30000 or fillTypeName ~= nil then		
		if not string.find(stringName, fillTypeName) then
			if string.len(stringName) > 0 then
				stringName = stringName.. " !".. fillTypeName;									
			else
				stringName = "!".. fillTypeName;
			end;								
		end;
	else
		if not string.find(stringName, tostring(moLanguageXml:getTxt("unknow"))) then
			if string.len(stringName) > 0 then
				stringName = stringName.. " ".. tostring(moLanguageXml:getTxt("unknow"));									
			else
				stringName = tostring(moLanguageXml:getTxt("unknow"));
			end;								
		end;	
	end;	
	return pricePerLiter, stringName
end;